#include <sourcemod>
#include <sdktools>
#undef REQUIRE_PLUGIN
#include <nativevotes>
#define REQUIRE_PLUGIN

#pragma semicolon 1
/*
	3.0.0 Beta6
	SourceMod標準のパネル型Voteの機能を再び取り込んだ。NativeVotes無しでも使える仕様に。
	L4D1+NativeVotes環境では、NativeVotes側が多言語機能に対応してないから英語のメッセージが表示されるはず。
	
	3.0.0 Beta5
	NativeVotes 1.0.0 beta2に合わせた。
	NativeVotesの多言語化対応。
	投票を始めた人を表示しないオプションを追加
	
	3.0.0 Beta4
	NativeVotes 0.8.0に合わせた。
*/
public Plugin:myinfo = 
{
	name = "L4D WarpSurvivorBots",
	author = "ArmGadge",
	description = "warp survivor bots to target client.",
	version = "3.0.1",
	url = "http://radiowave.moe.hm/"
}

new g_initiateclient;
new String:gs_playername[MAX_NAME_LENGTH];
new Handle:gh_cv_voteduration = INVALID_HANDLE;
new Handle:gh_cv_reqturnout = INVALID_HANDLE;
new Handle:gh_cv_showinitiator = INVALID_HANDLE;
//new Handle:gh_vote = INVALID_HANDLE;
new bool:gb_nativevotes = false;

public OnPluginStart()
{
	decl String:s_pluginver[32];
	GetPluginInfo(INVALID_HANDLE, PlInfo_Version, s_pluginver, sizeof(s_pluginver));
	CreateConVar("l4d_warpsb_version", s_pluginver, "Version of WarpSurvivorBots Plugin.", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	gh_cv_voteduration = CreateConVar("l4d_warpsb_voteduration", "20", 
		"How long time allow per voting. (int)[sec.]", 0, true, 0.0, false);
	gh_cv_reqturnout = CreateConVar("l4d_warpsb_reqturnout", "0.0", 
		"If not collected more than this percentage from clients, vote will fail. (float)[percent]", 0, true, 0.0, true, 100.0);
	gh_cv_showinitiator = CreateConVar("l4d_warpsb_showinitiator", "1", 
		"Change whether to show who initiate the vote. (0|1)", 0, true, 0.0, true, 1.0);
	
	RegConsoleCmd("sm_warpbot", Cmd_InitiateVote, "Initiate warp survivor bots vote.");
	RegConsoleCmd("sm_bot", Cmd_InitiateVote, "Initiate warp survivor bots vote.");
	
	AutoExecConfig(true, "l4d_warpsb");
	LoadTranslations("plugin.l4d_warpsb");
}

public OnAllPluginsLoaded()
{
	gb_nativevotes = LibraryExists("nativevotes");
}

public OnLibraryAdded(const String:name[])
{
	if (StrEqual(name, "nativevotes", false))
	{
		gb_nativevotes = true;
	}
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "nativevotes", false))
	{
		gb_nativevotes = false;
	}
}

public Action:Cmd_InitiateVote(client, args)
{
	if (client >= 1) ExecVote(client);

	return Plugin_Handled;
}

//Menu Handler
public Handle_VoteMenu(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		/* This is called after VoteEnd */
		CloseHandle(menu);
	}
	else if (action == MenuAction_Display)
	{
		new Handle:panel = Handle:param2;
		decl String:s_buffer[256];
		Format(s_buffer, sizeof(s_buffer), "%T %T", "VoteQuestionTitle", param1, "VoteQuestionText", param1, gs_playername);
		SetPanelTitle(panel, s_buffer);
	}
}

public Handle_VoteMenu_NV(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		NativeVotes_Close(menu);
	}
	else if (action == MenuAction_Display)
	{
		decl String:s_buffer[256];
		Format(s_buffer, sizeof(s_buffer), "%T", "VoteQuestionText", param1, gs_playername);
		//PrintToChatAll("translate %d, buffer=%s", param1, s_buffer);
		NativeVotes_RedrawVoteTitle(s_buffer);
		return _:Plugin_Changed;
	}
	else if (action == MenuAction_VoteCancel)
	{
		NativeVotes_DisplayFail(menu, NativeVotesFail_Generic);
		NativeVotes_Close(menu);
	}
	return 0;
}

//Vote Result Handler
public Handle_VoteResults(Handle:menu, 
			num_votes, 
			num_clients, 
			const client_info[][2], 
			num_items, 
			const item_info[][2])
{
	new String:choice[4], String:display[4];
	new yes_votes = 0;
	new Float:turnout = float(num_votes) / float(num_clients) * 100.0;	
	GetMenuItem(menu, item_info[0][VOTEINFO_ITEM_INDEX], choice, sizeof(choice), _, display, sizeof(display));
	if (turnout >= GetConVarFloat(gh_cv_reqturnout))
	{
		for (new i=0; i < num_items; i++)
		{
			if(StrEqual(choice, "yes"))
			{
				yes_votes = item_info[i][VOTEINFO_ITEM_VOTES];

			}
		}
		
		PrintToChatAll("[WarpSB] %t", "VoteCount", num_votes, yes_votes, num_votes - yes_votes);
		if (yes_votes > num_votes - yes_votes)
		{
			PrintToChatAll("[WarpSB] %t%t", "VotePassed", "VotePassedAction", gs_playername);
			PrintToServer("[WarpSB] Teleporting survivor bots...");
			CreateTimer(3.0, TeleportDelay, g_initiateclient);
		}
		else PrintToChatAll("[WarpSB] %t", "VoteFailed");
	}
	else PrintToChatAll("[WarpSB] %t", "VoteFailed_NotEnough");
}

public Handle_VoteResults_NV(Handle:vote,
							num_votes, 
							num_clients,
							const client_indexes[],
							const client_votes[],
							num_items,
							const item_indexes[],
							const item_votes[])
{
	decl String:choice[32], String:display[32];
	new yes_votes = 0;
	new Float:turnout = float(num_votes) / float(num_clients) * 100.0;	
	//PrintToChatAll("[Result] clients:%d votes: %d(%.1f%%), items: %d",
	//	num_clients, num_votes, turnout, num_items);

	if (turnout >= GetConVarFloat(gh_cv_reqturnout))
	{
		for (new i=0; i < num_items; i++)
		{
			NativeVotes_GetItem(vote, item_indexes[i], choice, sizeof(choice), display, sizeof(display));
			//PrintToChatAll("[item %d] index: %d choice: %s, display:%s, votes: %d", i, item_indexes[i], choice, display, item_votes[i]);
			
			if (StrEqual(choice, "yes")) yes_votes = item_votes[i];
		}
		
		/*
			Yes/Noの場合の可決条件: Yes票がNo票を超えること(Yes > No)
			No票数 = 投票総数(num_votes) - Yes票
		*/
		if (yes_votes > num_votes - yes_votes)
		{

			//カスタムメッセージの場合は、DisplayPassではなくDisplayPassCustomの方が正しいと思われる
			
			//decl String:passmsg[64];
			//Format(passmsg, sizeof(passmsg), "生存者Botを%sの所にワープさせます。", gs_playername);
			//NativeVotes_DisplayPass(vote, passmsg);
			
			NativeVotes_DisplayPassCustom(vote, "%t", "VotePassedAction", gs_playername);
			PrintToChatAll("[WarpSB] %t", "VotePassedAction", gs_playername);
			
			//この後に実処理
			CreateTimer(3.0, TeleportDelay, g_initiateclient);
		}
		else
		{
			NativeVotes_DisplayFail(vote, NativeVotesFail_Loses);
		}
	}
	else
	{
		NativeVotes_DisplayFail(vote, NativeVotesFail_NotEnoughVotes);
	}
}
	
ExecVote(client)
{
	g_initiateclient = client;
	GetClientName(g_initiateclient, gs_playername, sizeof(gs_playername));

	if (gb_nativevotes == true)
	{
		if (NativeVotes_IsNewVoteAllowed() == false)
		{
			new seconds = NativeVotes_CheckVoteDelay();
			ReplyToCommand(client, "[WarpSB] %t", "VoteNotAllowedNow", seconds);
			return;
		}
		

		new Handle:h_vote = NativeVotes_Create(Handle_VoteMenu_NV, NativeVotesType_Custom_YesNo,
			MenuAction_VoteStart|MenuAction_VoteCancel|MenuAction_VoteEnd|
			MenuAction_End|MenuAction_Display|MenuAction_DisplayItem);
		NativeVotes_SetResultCallback(h_vote, Handle_VoteResults_NV);
		decl String:qmsg[256];		
		/*
			メッセージについて
			L4DのVote画面では、MenuAction_Display等でVoteHandlerが呼び出されないため、
			クライアントごとにメッセージを書き換えることができず、多言語化ができないと考えられる。
			今回は、NativeVoteで表示するメッセージを日本語でベタ書きし、併せて多言語化したチャットメッセージを表示することで対処。
		*/
		//Format(qmsg, sizeof(qmsg), "生存者Botを%sの所にワープさせますか？", gs_playername);
		Format(qmsg, sizeof(qmsg), "Warp survivor bots to %s?", gs_playername);
		//NativeVotes_SetDetails(h_vote, qmsg);
		/*
			SetTitlesでもいけるらしい。というかSetTitlesじゃないと多言語対応できない。
		*/
		NativeVotes_SetTitle(h_vote, qmsg);
		/*
			SetInitiatorでクライアントを指定すると、
			投票パネルに、Votes called by （プレイヤー名）が表示される。
			また、そのクライアントは自動的にYesに投票された状態でスタートする。
			デフォルトのNATIVEVOTES_SERVER_INDEXの場合、サーバーが呼び出している扱いとなり、
			誰も投票してない状態からスタートする。
			したがって、投票を始めた人を匿名にするためには、NATIVEVOTES_SERVER_INDEXとし、
			スタート時にその人をFakeClientCommand(client, "Vote Yes")する。
		*/
		if (GetConVarBool(gh_cv_showinitiator) == true)
			NativeVotes_SetInitiator(h_vote, client);
		else NativeVotes_SetInitiator(h_vote, NATIVEVOTES_SERVER_INDEX);
		//NativeVotes_AddItem(gh_vote, "Yes", "Yes");
		//NativeVotes_AddItem(gh_vote, "No", "No");
		
		NativeVotes_DisplayToTeam(h_vote, 2, GetConVarInt(gh_cv_voteduration));
		//DispVote_Team(gh_vote, 2, GetConVarInt(gh_cv_voteduration));

		/*
			無投票だとResultCallbackした所でnativevotes.smx側にエラーが出るみたい？
			投票をコールした人は自動的にYesへ投票しとく。（L4D側で用意されているVote機能と同じ仕様に合わせる）
		*/
		
		if (GetConVarBool(gh_cv_showinitiator) == false)
			FakeClientCommand(client, "Vote Yes");
	}
	else
	{
		if (IsVoteInProgress())
		{
			return;
		}

		new Handle:menu = CreateMenu(Handle_VoteMenu, MenuAction_Display);
		SetVoteResultCallback(menu, Handle_VoteResults);
		SetMenuTitle(menu, "Vote: Warp survivor bots to player %s?", gs_playername);
		
		AddMenuItem(menu, "yes", "Yes");
		AddMenuItem(menu, "no", "No");

		SetMenuExitButton(menu, false);
		VoteMenuToAll(menu, 30);
	
	}
}

public Action:TeleportDelay(Handle:timer, any:client)
{
	new Float:origin[3];
	if (IsClientConnected(client) && IsClientInGame(client) && (GetClientTeam(client) == 2))
	{
		GetClientAbsOrigin(client, origin);
		for (new i=1; i<=MaxClients; i++)
		{
			// check survivor bots
			if (IsClientConnected(i) && IsClientInGame(i) && (GetClientTeam(i) == 2) && IsFakeClient(i))
			{
				TeleportEntity(i, origin, NULL_VECTOR, NULL_VECTOR);
			}
		}
	}
}